PrefabFiles = {
	"babyspat",
	"explosivegas",
	"explode_huge",
	"armorsteel",
	"hatsteel",
	"phlegmstaff"
}

Assets = {
	Asset("ATLAS","images/armorsteel.xml"),
	Asset("ATLAS","images/hatsteel.xml"),
	Asset("ATLAS","images/phlegmstaff.xml")
}

require = GLOBAL.require
local TUNING = GLOBAL.TUNING
local Vector3 = GLOBAL.Vector3
local SpawnPrefab = GLOBAL.SpawnPrefab

local Ingredient = GLOBAL.Ingredient
local Recipetabs = GLOBAL.RECIPETABS
local Recipe = GLOBAL.Recipe
local Tech = GLOBAL.TECH
local Strings = GLOBAL.STRINGS
local TheNet = GLOBAL.TheNet

GLOBAL.SPATFAMILY_FORCELANGUAGE = GetModConfigData("forceLanguage")

local pintarget = 
{
	"crow","robin","robin_winter","butterfly",
	"babybeefalo","perd","rabbit",
	"buzzard","penguin",
	"beefalo","bunnyman","koalephant_summer","koalephant_winter","krampus","pigman","rocky","lightninggoat",
	"monkey","slurtle","snurtle","catcoon",
	"spider_hider","spider_dropper","spider","spider_warrior","spider_spitter",
	"frog","hound","icehound","firehound","warg",
	"pigguard","walrus","merm","tallbirld","teenbird","smallbird","little_walrus",
	"bishop","bishop_nightmare","knight","knight_nightmare",
}

local pinboss =
{
	"bearger","dragonfly","deerclops","moose","spiderqueen","leif","leif_sparse",
}

local function pinfn1(inst)
	inst:AddComponent("pinnable")
	inst.components.pinnable.wearofftime = 2.5
end
local function pinfn2(inst)
	inst:AddComponent("pinnable")
	inst.components.pinnable.wearofftime = 1
end

for k=1, #pintarget do
	AddPrefabPostInit(pintarget[k], pinfn1)
end
for k=1, #pinboss do
	AddPrefabPostInit(pinboss[k], pinfn2)
end



AddRecipe("explosivegas", {Ingredient("glommerfuel", 5), Ingredient("phlegm", 3), Ingredient("gunpowder", 13)}, Recipetabs.REFINE, Tech.SCIENCE_TWO, nil, nil, nil, nil, nil, "images/inventoryimages.xml", "glommerfuel.tex")
AddRecipe("armorsteel", {Ingredient("steelwool", 3), Ingredient("pigskin", 3), Ingredient("armorwood", 1)}, Recipetabs.WAR, Tech.SCIENCE_TWO, nil, nil, nil, nil, nil, "images/armorsteel.xml", "armorsteel.tex")
AddRecipe("hatsteel", {Ingredient("steelwool", 3), Ingredient("pigskin", 1), Ingredient("footballhat", 1)}, Recipetabs.WAR, Tech.SCIENCE_TWO, nil, nil, nil, nil, nil, "images/hatsteel.xml", "hatsteel.tex")
AddRecipe("phlegmstaff", {Ingredient("spear", 1), Ingredient("phlegm", 5), Ingredient("spidergland", 8)}, Recipetabs.MAGIC, Tech.SCIENCE_TWO, nil, nil, nil, nil, nil, "images/phlegmstaff.xml", "phlegmstaff.tex")



-- ТЕКСТОВЫЕ ОПИСАНИЯ И ПЕРЕВОД ФРАЗ
local nm = Strings.NAMES
local rec = Strings.RECIPE_DESC
local true_desc = Strings.CHARACTERS.GENERIC.DESCRIBE
local desc = {}
local CLIENT_SIDE = CLIENT_SIDE or TheNet:GetIsClient() or TheNet:GetIsServer() and not TheNet:IsDedicated()
print("Spat Family: CLIENT_SIDE =", CLIENT_SIDE)



local function GetTranslates(lang, nm, rec, desc, forceLanguage)
	local defLang = GLOBAL.LanguageTranslator.defaultlang
	if defLang~=nil then
		if lang~=defLang and forceLanguage=="def" then
			lang = defLang
		end
	end
	-- print("lang =", lang)
	-- если активен мод руссификации
	if lang=="ru" then
		nm.EXPLOSIVEGAS = "Взрывчатый газ"
		desc.EXPLOSIVEGAS = "Хорошая газовая взрывчатка для подрыва деревьев!"
		rec.EXPLOSIVEGAS = "Широкий радиус чтобы взорвать деревья!"
		
		nm.ARMORSTEEL = "Стальная броня"
		desc.ARMORSTEEL = "Броня, хорошо отражающая физический урон"
		rec.ARMORSTEEL = "Стальная броня" -- "97.5% absorb, 2000HP, 75% damage reflect"
		
		nm.HATSTEEL = "Стальная шапка"
		desc.HATSTEEL = "Шапка, хорошо отражающая мокрую слизь"
		rec.HATSTEEL = "Стальная шапка" -- 97.5% absorb, 1500HP, 75% damage reflect"
		
		nm.PHLEGMSTAFF = "Посох слизовцы"
		desc.PHLEGMSTAFF = "Хороший посох для боя"
		rec.PHLEGMSTAFF = "Посох слизовцы" -- "attack 74, uses 200, 10% stick"
		
		nm.BABYSPAT = "Детёныш слизовцы"
		desc.BABYSPAT = "Какой уродливый детёныш!"
		
	-- если активен мод перевода китайский
	elseif lang=="chs" or lang=="cht" then
		nm.EXPLOSIVEGAS = "爆炸性气体"
		desc.EXPLOSIVEGAS = "好的气体爆炸物炸毁树木！"
		rec.EXPLOSIVEGAS = "一个广泛的半径炸掉的树木！"
		
		nm.ARMORSTEEL = "钢铁盔甲"
		desc.ARMORSTEEL = "盔甲，也反映物理损伤"
		rec.ARMORSTEEL = "钢铁盔甲" -- "97.5% absorb, 2000HP, 75% damage reflect"
		
		nm.HATSTEEL = "钢帽"
		desc.HATSTEEL = "帽，高反射湿泥"
		rec.HATSTEEL = "钢帽" -- 97.5% absorb, 1500HP, 75% damage reflect"
		
		nm.PHLEGMSTAFF = "工作人员粘膜羊"
		desc.PHLEGMSTAFF = "好的工作人员为战斗"
		rec.PHLEGMSTAFF = "工作人员粘膜羊" -- "attack 74, uses 200, 10% stick"
		
		nm.BABYSPAT = "幼崽粘膜羊"
		desc.BABYSPAT = "什么一个丑陋的宝贝！"
		
	-- по умолчанию описания на английском языке
	else
		nm.EXPLOSIVEGAS = "explosivegas"
		desc.EXPLOSIVEGAS = "A good gas explosive to blow down trees! "
		rec.EXPLOSIVEGAS = "A wide-range gasexplosive to blow down trees!"
		
		nm.ARMORSTEEL = "armorsteel"
		desc.ARMORSTEEL = "A good armor to reflect physic damage to your enemy "
		rec.ARMORSTEEL = "97.5% absorb, 2000HP, 75% damage reflect"
		
		nm.HATSTEEL = "hatsteel"
		desc.HATSTEEL = "A good hat to reflect phlegm to your enemy "
		rec.HATSTEEL = "97.5% absorb, 1500HP, 75% damage reflect"
		
		nm.PHLEGMSTAFF = "phlegmstaff"
		desc.PHLEGMSTAFF = "A good staff randomly stick your enemy "
		rec.PHLEGMSTAFF = "attack 74, uses 200, 10% stick"
		
		nm.BABYSPAT = "babyspat"
		desc.BABYSPAT = "Their child is ugly, too"
	end
end

function Translate()
	-- print("Перевод фраз на клиенте")
	local forceLanguage = GLOBAL.SPATFAMILY_FORCELANGUAGE
	local lang = GLOBAL.LanguageTranslator.defaultlang
	-- print("Определёно: lang = ", lang, "; forceLanguage = ", forceLanguage)
	if lang~=nil then
		local SupportedLangs = { en=1, chs=1, cht="chs", TW="chs", ru=1, } -- 1 указывает на существование файла, строка переводит на другой языковый файл.
		local sign = SupportedLangs[lang]
		-- print("Определёно существование перевода:", tostring(sign))
		if sign~=1 then
			lang = sign -- Если nil, то просто отключаем. Если переадресация, то указывается новый язык.
		end
		if forceLanguage~="def" then
			lang = forceLanguage
		end
		if sign~=nil then
			speech_tbl = {}
			function AddSpeech(orig, val) -- val can't be nil
				if orig==nil or val=="" then return end -- no empty strings
				speech_tbl[orig] = val
				-- print("Замена ", tostring(orig), " на ", tostring(val))
			end
			local function TranslateTo(message) -- Возвращает перевод или nil в случае отсутствия.
				-- Умная функция отбрасывает всё после \n, а потом снова склеивает с хвостом.
				if message and type(message)=="string" then
					-- print("message = ", message)
					local find_n = string.find(message, "\n", 1, true)
					local cut_mess = find_n==nil and message or message:sub(1, find_n-1)
					-- print("cut_mess = ", cut_mess)
					if speech_tbl[cut_mess] then
						-- print("return speech_tbl[message] = ", speech_tbl[message])
						return speech_tbl[message]
						-- return find_n==nil and speech_tbl[cut_mess] or speech_tbl[cut_mess] .. message:sub(find_n)
					end
				end
			end
			-- перевод на произносимого на сервере. В смысле, на хосте, но без пересылки по сети клиентам.
			if TheNet.Talker then
				GLOBAL.getmetatable(TheNet).__index.Talker = (function()
					local oldTalker = GLOBAL.getmetatable(TheNet).__index.Talker
					return function(self, message, entity, ...)
						-- print("Перевод произносимого на сервере: message = ", message)
						-- print("oldTalker =", tostring(message))
						oldTalker(self, message, entity, ...)
						-- print("entity =", tostring(entity))
						local inst = entity and entity:GetGUID() or nil
						inst = inst and GLOBAL.Ents[inst] or nil -- определяем инстанс персонажа по entity
						-- print("inst =",tostring(inst))
						if inst and inst.components.talker.widget  then -- если он может говорить
							message = TranslateTo(message)
							-- print("Полученный перевод произносимого на стороне сервера: message = ", message)
							if message and type(message)=="string" then
								-- print("Trans =", message)
								inst.components.talker.widget.text:SetString(message) -- меняем текст
							end
						end
					end
				end)()
			end
			-- перевод сообщения на стороне клиента
			if GLOBAL.rawget(GLOBAL,"Networking_Talk") then
				local OldNetworking_Talk = GLOBAL.Networking_Talk
				function Networking_Talk(guid, message, ...)
					-- print("Перевод произносимого на стороне клиента: message = ", message)
					-- local entity = GLOBAL.Ents[guid]
					-- message=t.TranslateTo(message,entity) or message --Переводим на русский
					message = TranslateTo(message) or message
					-- print("Полученный перевод произносимого на стороне клиента: message = ", message)
					OldNetworking_Talk(guid, message, ...)
				end
				GLOBAL.Networking_Talk = Networking_Talk
			end
			-- print("Spat Family Detected language:", lang")
			-- desc = {} -- Скрываем реальные константы, т.к. на сервере они не нужны. А на клиенте будет функция. --!!!TODO
			GetTranslates(lang, nm, rec, desc, forceLanguage)
			-- print("Structure desc and replace:")
			for k,v in pairs(desc) do -- for k,v in pairs(desc) do Добавляем реплики
				-- msg = "k = " .. tostring(k) .. "; v = " .. tostring(v) .. "; true_desc[k] = " .. tostring(true_desc[k])
				-- print(msg)
				AddSpeech(true_desc[k], v)
			end
			-- print("Structure speech_tbl:")
			-- for k,v in pairs(speech_tbl) do
				-- msg = "k = " .. tostring(k) .. "; v = " .. tostring(v)
				-- print(msg)
			-- end
		end
	end
end

-- переведём текст на язык по умолчанию на стороне сервера
if not (GLOBAL.KnownModIndex and GLOBAL.KnownModIndex.savedata and GLOBAL.KnownModIndex.savedata.known_mods) then
	-- print("Spat Family: Can't find KnownModIndex!")
	return
end
local useLanguage = "en"
print("Spat Family: useLanguage==", useLanguage) -- , " по умолчанию")

if GLOBAL.SPATFAMILY_FORCELANGUAGE=="def" then
	-- print("Spat Family: useLanguage==", useLanguage, " после определения языка")
	GetTranslates(useLanguage, nm, rec, true_desc, useLanguage) -- по умолчанию грузим английский перевод
else
	-- print("Spat Family: useLanguage==", useLanguage, " после определения языка")
	GetTranslates(GLOBAL.SPATFAMILY_FORCELANGUAGE, nm, rec, true_desc, useLanguage) -- грузим принудительный перевод
end
-- переводим фразы
if CLIENT_SIDE then AddPrefabPostInit("world", Translate, GLOBAL.SPATFAMILY_FORCELANGUAGE) end
