local assets =
{
	Asset("ANIM", "anim/armorsteel.zip"),
}

local function OnBlocked(owner) 
	owner.SoundEmitter:PlaySound("dontstarve/wilson/hit_armour")
end

local function onequip(inst, owner) 
	inst.reflectfn = function(attacked, data)
		if data and data.attacker and data.attacker.components.health ~=nil and data.attacker.components.combat ~= nil then
			local fx = SpawnPrefab("groundpoundring_fx")
			fx.Transform:SetPosition(owner.Transform:GetWorldPosition())
			fx.Transform:SetScale(0.5, 0.5, 0.5)
			if data.damage then
				data.attacker.components.combat:GetAttacked(owner, data.damage*0.33)
			end
		end 
	end
	inst:ListenForEvent("attacked", inst.reflectfn, owner)

	owner.AnimState:OverrideSymbol("swap_body", "armorsteel", "swap_body")
	inst:ListenForEvent("blocked", OnBlocked, owner)
end

local function onunequip(inst, owner)
	inst:RemoveEventCallback("attacked", inst.reflectfn, owner)

	owner.AnimState:ClearOverrideSymbol("swap_body")
	inst:RemoveEventCallback("blocked", OnBlocked, owner)
end

local function fn()
	local inst = CreateEntity()

	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddNetwork()

	MakeInventoryPhysics(inst)

	inst.AnimState:SetBank("armor_wood")
	inst.AnimState:SetBuild("armorsteel")
	inst.AnimState:PlayAnimation("anim")

	inst.entity:SetPristine()

	if not TheWorld.ismastersim then
		return inst
	end

	inst:AddComponent("inspectable")

	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.imagename = "armorsteel"
	inst.components.inventoryitem.atlasname = "images/armorsteel.xml"

	inst:AddComponent("fuel")
	inst.components.fuel.fuelvalue = TUNING.LARGE_FUEL

	MakeSmallBurnable(inst, TUNING.SMALL_BURNTIME)
	MakeSmallPropagator(inst)

	inst:AddComponent("armor")
	inst.components.armor:InitCondition(TUNING.ARMORMARBLE*1.35, .9) -- TUNING.ARMORMARBLE = wilson_health*7*multiplayer_armor_durability_modifier, wilson_health = 150, multiplayer_armor_durability_modifier = 0.7


	inst:AddComponent("equippable")
	inst.components.equippable.equipslot = EQUIPSLOTS.BODY

	inst.components.equippable:SetOnEquip(onequip)
	inst.components.equippable:SetOnUnequip(onunequip)

	return inst
end

return Prefab("common/inventory/armorsteel", fn, assets)
