local assets =
{
	Asset("ANIM", "anim/glommer_fuel.zip"),
	Asset("ANIM", "anim/explode.zip"),
}

local prefabs =
{
	"explode_huge",
}

--[[local function OnIgniteFn(inst)
	inst.SoundEmitter:PlaySound("dontstarve/common/blackpowder_fuse_LP", "hiss")
end]]

local function OnExplodeFn(inst)
	inst.SoundEmitter:KillSound("hiss")
	inst.SoundEmitter:PlaySound("dontstarve/common/blackpowder_explo")

	SpawnPrefab("explode_huge").Transform:SetPosition(inst.Transform:GetWorldPosition())
end

local function OnPutInInv(inst, owner)
	if owner.prefab == "mole" then
		inst.components.explosive:OnBurnt()
	end
end

local function fn()
	local inst = CreateEntity()

	inst.entity:AddTransform()
	inst.Transform:SetScale(1.5,1.5,1.5)
	inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()
	inst.entity:AddNetwork()

	MakeInventoryPhysics(inst)

	inst.AnimState:SetBank("glommer_fuel")
	inst.AnimState:SetBuild("glommer_fuel")
	inst.AnimState:PlayAnimation("idle")

	--inst:AddTag("molebait")

	inst.entity:SetPristine()

	if not TheWorld.ismastersim then
		return inst
	end

	inst:AddComponent("stackable")
	inst.components.stackable.maxsize = 10

	inst:AddComponent("inspectable")

	MakeSmallBurnable(inst, 3)
	--MakeSmallPropagator(inst)
	--V2C: Remove default OnBurnt handler, as it conflicts with
	--explosive component's OnBurnt handler for removing itself
	inst.components.burnable:SetOnBurntFn(nil)

	inst:AddComponent("explosive")
	inst.components.explosive:SetOnExplodeFn(OnExplodeFn)
	--inst.components.explosive:SetOnIgniteFn(OnIgniteFn)
	inst.components.explosive.explosivedamage = 150
	inst.components.explosive.explosiverange = 55
	inst.components.explosive.buildingdamage = 200

	function inst.components.explosive:OnBurnt()
		for i, v in ipairs(AllPlayers) do
			local distSq = v:GetDistanceSqToInst(self.inst)
			local k = math.max(0, math.min(1, distSq / 1600))
			local intensity = k * (k - 2) + 1 --easing.outQuad(k, 1, -1, 1)
			if intensity > 0 then
				v:ScreenFlash(intensity)
				v:ShakeCamera(CAMERASHAKE.FULL, .7, .02, intensity / 2)
			end
		end

		if self.onexplodefn ~= nil then
			self.onexplodefn(self.inst)
		end

		local stacksize = self.inst.components.stackable ~= nil and self.inst.components.stackable:StackSize() or 1
		local totaldamage = self.explosivedamage * stacksize

		local x, y, z = self.inst.Transform:GetWorldPosition()
		local ents = TheSim:FindEntities(x, y, z, self.explosiverange, nil, { "INLIMBO" })

		for i, v in ipairs(ents) do
			if v ~= self.inst and v:IsValid() and not v:IsInLimbo() then
				if v.components.workable ~= nil and v.components.workable:CanBeWorked() then
					v.components.workable:WorkedBy(self.inst, self.buildingdamage)
				end

				--Recheck valid after work
				if v:IsValid() and not v:IsInLimbo() then
					if self.lightonexplode and
						v.components.fueled == nil and
						v.components.burnable ~= nil and
						not v.components.burnable:IsBurning() and
						not v:HasTag("burnt") then
						--v.components.burnable:Ignite()
					end

					if v.components.combat ~= nil then
						v.components.combat:GetAttacked(self.inst, totaldamage, nil)
					end

					v:PushEvent("explosion", { explosive = self.inst })
				end
			end
		end

		local world = TheWorld
		for i = 1, stacksize do
			world:PushEvent("explosion", { damage = self.explosivedamage })
		end

		if self.inst.components.health ~= nil then
			self.inst:PushEvent("death")
		end

		self.inst:Remove()
	end

	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.imagename = "glommerfuel"
	inst.components.inventoryitem.atlasname = "images/inventoryimages.xml"
	inst.components.inventoryitem:SetOnPutInInventoryFn(OnPutInInv)

	inst:AddComponent("bait")

	--MakeHauntableLaunchAndIgnite(inst)

	return inst
end

return Prefab("common/inventory/explosivegas", fn, assets, prefabs)