local assets =
{
	Asset("ANIM", "anim/hatsteel.zip"),
}

local function OnBlocked(owner)
	owner.SoundEmitter:PlaySound("dontstarve/wilson/hit_armour")
end

local function onequip(inst, owner)
	inst.reflectfn = function(attacked, data)
	if data and data.attacker and data.attacker.components.health ~=nil and data.attacker.components.combat ~= nil then
		local fx = SpawnPrefab("groundpoundring_fx")
		fx.Transform:SetPosition(owner.Transform:GetWorldPosition())
		fx.Transform:SetScale(0.5,0.5,0.5)
		if data.damage then
			data.attacker.components.combat:GetAttacked(owner, data.damage*0.33)
		end
	end 
	end
	inst:ListenForEvent("attacked", inst.reflectfn, owner)

	owner.AnimState:OverrideSymbol("swap_hat", "hatsteel", "swap_hat")
	owner.AnimState:Show("HAT")
	owner.AnimState:Show("HAT_HAIR")
	owner.AnimState:Hide("HAIR_NOHAT")
	owner.AnimState:Hide("HAIR")

	if owner:HasTag("player") then
	owner.AnimState:Hide("HEAD")
	owner.AnimState:Show("HEAD_HAT")
	end

	inst:ListenForEvent("blocked", OnBlocked, owner)
end

local function onunequip(inst, owner)
	inst:RemoveEventCallback("attacked", inst.reflectfn, owner)

	owner.AnimState:ClearOverrideSymbol("swap_hat")
	owner.AnimState:Hide("HAT")
	owner.AnimState:Hide("HAT_HAIR")
	owner.AnimState:Show("HAIR_NOHAT")
	owner.AnimState:Show("HAIR")

	if owner:HasTag("player") then
		owner.AnimState:Show("HEAD")
		owner.AnimState:Hide("HEAD_HAT")
	end

	inst:RemoveEventCallback("blocked", OnBlocked, owner)
end

local function fn()
	local inst = CreateEntity()

	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddNetwork()

	MakeInventoryPhysics(inst)

	inst.AnimState:SetBank("footballhat")
	inst.AnimState:SetBuild("hatsteel")
	inst.AnimState:PlayAnimation("anim")

	inst.entity:SetPristine()

	if not TheWorld.ismastersim then
		return inst
	end

	inst:AddComponent("inspectable")

	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.imagename = "hatsteel"
	inst.components.inventoryitem.atlasname = "images/hatsteel.xml"

	inst:AddComponent("fuel")
	inst.components.fuel.fuelvalue = TUNING.LARGE_FUEL

	MakeSmallBurnable(inst, TUNING.SMALL_BURNTIME)
	MakeSmallPropagator(inst)

	inst:AddComponent("armor")
	inst.components.armor:InitCondition(TUNING.ARMOR_FOOTBALLHAT*2.8, .9) -- ARMOR_FOOTBALLHAT = wilson_health*3*multiplayer_armor_durability_modifier, wilson_health = 150, multiplayer_armor_durability_modifier = 0.7

	inst:AddComponent("equippable")
	inst.components.equippable.equipslot = EQUIPSLOTS.HEAD

	inst.components.equippable:SetOnEquip(onequip)
	inst.components.equippable:SetOnUnequip(onunequip)

	return inst
end

return Prefab("common/inventory/hatsteel", fn, assets)
