local assets =
{
	Asset("ANIM", "anim/phlegmstaff.zip"),
	Asset("ANIM", "anim/swap_phlegmstaff.zip"),
}

local function onequip(inst, owner)
	inst.attackfn = function(onattackother,data)
		if data and data.target and data.target.components.health ~=nil and data.target.components.combat ~= nil then
			if math.random() < .10 then
				inst.components.weapon:SetProjectile("spat_bomb")
			else 
				inst.components.weapon:SetProjectile(nil)
			end
		end
	end
	inst:ListenForEvent("onattackother", inst.attackfn, owner)

	owner.AnimState:OverrideSymbol("swap_object", "swap_phlegmstaff", "swap_spear")
	owner.AnimState:Show("ARM_carry")
	owner.AnimState:Hide("ARM_normal")
end

local function onunequip(inst, owner)
	inst:RemoveEventCallback("onattackother", inst.attackfn, owner)
	owner.AnimState:Hide("ARM_carry")
	owner.AnimState:Show("ARM_normal")
end

local function fn()
	local inst = CreateEntity()

	inst.entity:AddTransform()
	inst.entity:AddAnimState()
	inst.entity:AddNetwork()

	MakeInventoryPhysics(inst)

	inst.AnimState:SetBank("spear")
	inst.AnimState:SetBuild("phlegmstaff")
	inst.AnimState:PlayAnimation("idle")

	inst:AddTag("sharp")

	inst.entity:SetPristine()

	if not TheWorld.ismastersim then
		return inst
	end

	inst:AddComponent("weapon")
	inst.components.weapon:SetDamage(74)

	-------

	inst:AddComponent("finiteuses")
	inst.components.finiteuses:SetMaxUses(200)
	inst.components.finiteuses:SetUses(200)

	inst.components.finiteuses:SetOnFinished(inst.Remove)

	inst:AddComponent("inspectable")

	inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.imagename = "phlegmstaff"
	inst.components.inventoryitem.atlasname = "images/phlegmstaff.xml"

	inst:AddComponent("fuel")
	inst.components.fuel.fuelvalue = TUNING.LARGE_FUEL

	MakeSmallBurnable(inst, TUNING.SMALL_BURNTIME)
	MakeSmallPropagator(inst)

	inst:AddComponent("equippable")
	inst.components.equippable:SetOnEquip(onequip)
	inst.components.equippable:SetOnUnequip(onunequip)

	return inst
end

return Prefab("phlegmstaff", fn, assets)